<!DOCTYPE html>
<html>
<body>
<script>    
var a = ['a', 'b', 'c'];
document.write(Object.keys(a)); 
document.write("<br>",a);

// array-like object
var b = {1:['a', 'b', 'c'],4 : 'a', 2: 'b', 3: 'c' };
var k=Object.keys(b); 
document.write("<br>",Object.values(b));
for (i of k)
{
    document.write("</br>"+i+" ");
    document.write(b[i]);
}

// array-like object with random key ordering
var c = { 100: '200', 2: '6', 7: '76' };
document.write("<br>",Object.keys(c)); 
document.write("<br>",Object.values(c));

//defineproperty
var obj={}
Object.defineProperty(obj, 'p1', {value: 42,  writable: false});
obj.p1="chandana";
document.write("<br>",obj.p1);
console.log(obj.p1);

//defineproperties
Object.defineProperties(obj, {
  p2: {
    value: "chandu",
    writable: false
  },
  p3: {
  value: 48,
   writable: true}
});
obj.p2="chandana";
obj.p3="teju";
document.write("<br>",obj.p2);
document.write("<br>",obj.p3);
console.log(obj.p2);
console.log(obj.p3);

//promises 
//case -1
var p = new Promise((resolve, reject) => {  
    let x=0; 
    let y=1; 
    
    if(x!=y) {    
        resolve('resolved ');  
    } else {   
        reject('rejected');  
    }
});
p.then((m) => { console.log(m);}).
catch((m) => { console.log(m);});

//case-2
var p = new Promise((resolve, reject) => {  
    let x=0; 
    let y=1; 
    
    if(x!=y) {    
        resolve('resolved ');  
    } else {   
        reject('rejected');  
    }
});
p.then(
    (m)=>{console.log(m)},
    (m)=>{console.log(m)});

p.catch((m) => {console.log(m)});

//case-3
var p = new Promise((resolve, reject) => 
{
    resolve();  
    reject();  
});
p.then(
    (m)=>{console.log("in resolve")},
    (m)=>{console.log("in reject")});

p.catch((m) => {console.log("in catch")});


//case-4
var p = new Promise((resolve, reject) => 
{  
    reject();  
    resolve();
});
p.then(
    (m)=>{console.log("in resolve")},
    (m)=>{console.log("in reject")})

.catch((m) => {console.log("in catch")});

//case-5
var p = new Promise((resolve, reject) => 
{   if(0)
    resolve();
    else  
    reject();
});
p.then(
    ()=>{console.log("in resolve")},
    ()=>{console.log("in reject")})
.catch(() => {console.log("in catch")});
p.catch(() => {console.log("out catch")});

//case-6
var p = new Promise((resolve, reject) => 
{   if(0)
    resolve();
    else  
    reject();
});
p.then(
    ()=>{console.log("in resolve1")},
    ()=>{console.log("in reject1")})
.catch(() => {console.log("in catch1")});
p.then(
    ()=>{console.log("in resolve2")},
    ()=>{console.log("in reject2")})
.catch(() => {console.log("in catch2")});
p.catch(() => {console.log("out catch")});

//case-7
var p = new Promise((resolve, reject) => 
{
    if(1)
    resolve();
    else
    reject();
});
p.then(
    ()=>{console.log("in resolve1")})
.catch(() => {console.log("in catch1")});
p.then(
    ()=>{console.log("in resolve2")})

.catch(() => {console.log("in catch2")});
p.catch(() => {console.log("out catch")});

//case-8
var p = new Promise((resolve, reject) => 
{
    if(0)
    resolve();
    else
    reject();
});
p.then(
    ()=>{console.log("in resolve1")})
.catch(() => {console.log("in catch1")});
p.then(
    ()=>{console.log("in resolve2")})

.catch(() => {console.log("in catch2")});
p.catch(() => {console.log("out catch")});

//setTimeout
var x = new Promise((resolve, reject) => 
{  
    setTimeout(resolve,3000,"success");
    // reject(); if we give another function like reject it will take reject without waiting  
});
x.then(
    (m)=>{console.log("in resolve")},
    (m)=>{console.log("in reject")})

.catch((m) => {console.log("in catch")});

//promises.all()
var p1 = Promise.resolve(4);
var p2 = 4444;
var p3 = new Promise((resolve, reject) => {
  setTimeout(resolve, 100, 'chandu');
});

Promise.all([p1,p2,p3]).then((messages) => {
  console.log(messages);
});

//prototype
function fun1(fname,lname,age)
{
    this.firstname=fname;
    this.lastname=lname;
    this.age=age;
}
fun1.prototype.name = function() {
  return this.firstname + " " + this.lastname
};
var fun2 = new fun1("chandana","vipparla","20");
console.log(fun2.name()); 
</script>
</body>
</html>